
package org.mule.modules.jobvite.config;

import java.util.List;
import org.apache.commons.lang.StringUtils;
import org.mule.config.spring.MuleHierarchicalBeanDefinitionParserDelegate;
import org.mule.config.spring.util.SpringXMLUtils;
import org.mule.modules.jobvite.processors.UpdateEmployeesMessageProcessor;
import org.mule.util.TemplateParser;
import org.springframework.beans.MutablePropertyValues;
import org.springframework.beans.PropertyValue;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.beans.factory.config.RuntimeBeanReference;
import org.springframework.beans.factory.support.BeanDefinitionBuilder;
import org.springframework.beans.factory.support.ManagedList;
import org.springframework.beans.factory.support.ManagedMap;
import org.springframework.beans.factory.xml.BeanDefinitionParser;
import org.springframework.beans.factory.xml.ParserContext;
import org.springframework.util.xml.DomUtils;
import org.w3c.dom.Element;

public class UpdateEmployeesDefinitionParser
    implements BeanDefinitionParser
{

    /**
     * Mule Pattern Info
     * 
     */
    private TemplateParser.PatternInfo patternInfo;

    public UpdateEmployeesDefinitionParser() {
        patternInfo = TemplateParser.createMuleStyleParser().getStyle();
    }

    public BeanDefinition parse(Element element, ParserContext parserContent) {
        BeanDefinitionBuilder builder = BeanDefinitionBuilder.rootBeanDefinition(UpdateEmployeesMessageProcessor.class.getName());
        String configRef = element.getAttribute("config-ref");
        if ((configRef!= null)&&(!StringUtils.isBlank(configRef))) {
            builder.addPropertyValue("moduleObject", configRef);
        }
        if ((element.getAttribute("companyId")!= null)&&(!StringUtils.isBlank(element.getAttribute("companyId")))) {
            builder.addPropertyValue("companyId", element.getAttribute("companyId"));
        }
        if ((element.getAttribute("importerEmail")!= null)&&(!StringUtils.isBlank(element.getAttribute("importerEmail")))) {
            builder.addPropertyValue("importerEmail", element.getAttribute("importerEmail"));
        }
        if ((element.getAttribute("reportEmail")!= null)&&(!StringUtils.isBlank(element.getAttribute("reportEmail")))) {
            builder.addPropertyValue("reportEmail", element.getAttribute("reportEmail"));
        }
        if ((element.getAttribute("doNotSyncOnWarnings")!= null)&&(!StringUtils.isBlank(element.getAttribute("doNotSyncOnWarnings")))) {
            builder.addPropertyValue("doNotSyncOnWarnings", element.getAttribute("doNotSyncOnWarnings"));
        }
        if ((element.getAttribute("overwriteEmployeeNamesAndEmail")!= null)&&(!StringUtils.isBlank(element.getAttribute("overwriteEmployeeNamesAndEmail")))) {
            builder.addPropertyValue("overwriteEmployeeNamesAndEmail", element.getAttribute("overwriteEmployeeNamesAndEmail"));
        }
        Element employeeUpdatesListElement = null;
        employeeUpdatesListElement = DomUtils.getChildElementByTagName(element, "employee-updates");
        List<Element> employeeUpdatesListChilds = null;
        if (employeeUpdatesListElement!= null) {
            String employeeUpdatesRef = employeeUpdatesListElement.getAttribute("ref");
            if ((employeeUpdatesRef!= null)&&(!StringUtils.isBlank(employeeUpdatesRef))) {
                if ((!employeeUpdatesRef.startsWith(patternInfo.getPrefix()))&&(!employeeUpdatesRef.endsWith(patternInfo.getSuffix()))) {
                    builder.addPropertyValue("employeeUpdates", new RuntimeBeanReference(employeeUpdatesRef));
                } else {
                    builder.addPropertyValue("employeeUpdates", employeeUpdatesRef);
                }
            } else {
                ManagedList employeeUpdates = new ManagedList();
                employeeUpdatesListChilds = DomUtils.getChildElementsByTagName(employeeUpdatesListElement, "employee-update");
                if (employeeUpdatesListChilds!= null) {
                    for (Element employeeUpdatesChild: employeeUpdatesListChilds) {
                        String valueRef = employeeUpdatesChild.getAttribute("value-ref");
                        if ((valueRef!= null)&&(!StringUtils.isBlank(valueRef))) {
                            if ((!valueRef.startsWith(patternInfo.getPrefix()))&&(!valueRef.endsWith(patternInfo.getSuffix()))) {
                                employeeUpdates.add(new RuntimeBeanReference(valueRef));
                            } else {
                                employeeUpdates.add(valueRef);
                            }
                        } else {
                            List<Element> inneremployeeupdateMapChilds = null;
                            if (employeeUpdatesChild!= null) {
                                String inneremployeeupdateRef = employeeUpdatesChild.getAttribute("ref");
                                if ((inneremployeeupdateRef!= null)&&(!StringUtils.isBlank(inneremployeeupdateRef))) {
                                    if ((!inneremployeeupdateRef.startsWith(patternInfo.getPrefix()))&&(!inneremployeeupdateRef.endsWith(patternInfo.getSuffix()))) {
                                        builder.addPropertyValue("inner-employee-update", new RuntimeBeanReference(inneremployeeupdateRef));
                                    } else {
                                        builder.addPropertyValue("inner-employee-update", inneremployeeupdateRef);
                                    }
                                } else {
                                    ManagedMap inneremployeeupdate = new ManagedMap();
                                    inneremployeeupdateMapChilds = DomUtils.getChildElementsByTagName(employeeUpdatesChild, "inner-employee-update");
                                    if (inneremployeeupdateMapChilds!= null) {
                                        if (inneremployeeupdateMapChilds.size() == 0) {
                                            inneremployeeupdateMapChilds = DomUtils.getChildElements(employeeUpdatesChild);
                                        }
                                        for (Element inneremployeeupdateChild: inneremployeeupdateMapChilds) {
                                            String inneremployeeupdateValueRef = inneremployeeupdateChild.getAttribute("value-ref");
                                            String inneremployeeupdateKeyRef = inneremployeeupdateChild.getAttribute("key-ref");
                                            Object valueObject = null;
                                            Object keyObject = null;
                                            if ((inneremployeeupdateValueRef!= null)&&(!StringUtils.isBlank(inneremployeeupdateValueRef))) {
                                                if ((!inneremployeeupdateValueRef.startsWith(patternInfo.getPrefix()))&&(!inneremployeeupdateValueRef.endsWith(patternInfo.getSuffix()))) {
                                                    valueObject = new RuntimeBeanReference(inneremployeeupdateValueRef);
                                                } else {
                                                    valueObject = inneremployeeupdateValueRef;
                                                }
                                            } else {
                                                valueObject = inneremployeeupdateChild.getTextContent();
                                            }
                                            if ((inneremployeeupdateKeyRef!= null)&&(!StringUtils.isBlank(inneremployeeupdateKeyRef))) {
                                                keyObject = new RuntimeBeanReference(inneremployeeupdateKeyRef);
                                            } else {
                                                keyObject = inneremployeeupdateChild.getAttribute("key");
                                            }
                                            if ((keyObject == null)||((keyObject instanceof String)&&StringUtils.isBlank(((String) keyObject)))) {
                                                keyObject = inneremployeeupdateChild.getTagName();
                                            }
                                            inneremployeeupdate.put(keyObject, valueObject);
                                        }
                                    }
                                    employeeUpdates.add(inneremployeeupdate);
                                }
                            }
                        }
                    }
                }
                builder.addPropertyValue("employeeUpdates", employeeUpdates);
            }
        }
        BeanDefinition definition = builder.getBeanDefinition();
        definition.setAttribute(MuleHierarchicalBeanDefinitionParserDelegate.MULE_NO_RECURSE, Boolean.TRUE);
        MutablePropertyValues propertyValues = parserContent.getContainingBeanDefinition().getPropertyValues();
        if (parserContent.getContainingBeanDefinition().getBeanClassName().equals("org.mule.config.spring.factories.PollingMessageSourceFactoryBean")) {
            propertyValues.addPropertyValue("messageProcessor", definition);
        } else {
            if (parserContent.getContainingBeanDefinition().getBeanClassName().equals("org.mule.enricher.MessageEnricher")) {
                propertyValues.addPropertyValue("enrichmentMessageProcessor", definition);
            } else {
                PropertyValue messageProcessors = propertyValues.getPropertyValue("messageProcessors");
                if ((messageProcessors == null)||(messageProcessors.getValue() == null)) {
                    propertyValues.addPropertyValue("messageProcessors", new ManagedList());
                }
                List listMessageProcessors = ((List) propertyValues.getPropertyValue("messageProcessors").getValue());
                listMessageProcessors.add(definition);
            }
        }
        return definition;
    }

    protected String getAttributeValue(Element element, String attributeName) {
        if (!StringUtils.isEmpty(element.getAttribute(attributeName))) {
            return element.getAttribute(attributeName);
        }
        return null;
    }

    private String generateChildBeanName(Element element) {
        String id = SpringXMLUtils.getNameOrId(element);
        if (StringUtils.isBlank(id)) {
            String parentId = SpringXMLUtils.getNameOrId(((Element) element.getParentNode()));
            return ((("."+ parentId)+":")+ element.getLocalName());
        } else {
            return id;
        }
    }

}
